import { Layout, Txt, makeScene2D } from "@motion-canvas/2d";
import {
  Direction,
  beginSlide,
  createRef,
  slideTransition,
} from "@motion-canvas/core";
import { theme } from "../theme";

const recursion = ["Y = λ f . (λ x . f (x x)) (λ x . f (x x))"];

export default makeScene2D(function* (view) {
  const lines = createRef<Txt>();

  view.add(
    <Layout layout direction="column" alignItems="center">
      <Txt fontSize={40} fontFamily={theme.font} fill={theme.text.hex}>
        Recursion and Combinators
      </Txt>
      <Txt
        ref={lines}
        fontSize={30}
        fontFamily={theme.font}
        fill={theme.text.hex}
      ></Txt>
    </Layout>
  );

  yield* slideTransition(Direction.Right);
  yield* beginSlide("The Lambda Calculus - Church Encoding");

  for (const line of recursion) {
    yield* lines().text(lines().text() + "\n\n" + line, 1);
    yield* beginSlide("recursion - " + line);
  }
});
